



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 4946 Area of Mushroom（2014 Multi-University Training Contest 8）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 4946 Area of Mushroom（2014 Multi-University Training Contest 8）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 21:20:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>思路： 只有速度最大才有可能为1，速度不是最大肯定为0，那么就是 只需要操作那些速度最大的点，这些点求一个凸包，判断一下是不是在凸包边上即可。</p>
<p>有几个需要注意的地方：</p>
<p>1.最大速度如果为0 &nbsp; 那么肯定所有都不行。</p>
<p>2.如果最大速度有重点那么 也都不行。</p>
<p>3.有些求凸包模板求出来的凸包可能有重点，要去重再求。</p>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;vector&gt;<br />
#include &lt;iostream&gt;<br />
#define EPS 1e-8<br />
#define eps 1e-8<br />
using namespace std;<br />
struct TPoint<br />
{<br />
    double x,y;<br />
    int id,v;<br />
}p[],s[],hull[],pp[];<br />
double cross(TPoint a, TPoint b, TPoint c) {<br />
    return (b.x - a.x) * (c.y - a.y) - (c.x - a.x)*(b.y - a.y);<br />
}<br />
double dis(TPoint a,TPoint b)<br />
{<br />
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));<br />
}<br />
bool graham_cmp(const TPoint &amp;b, const TPoint &amp;c) {<br />
    double tmp = cross(b, c, p[]);<br />
    if (tmp &gt; EPS)<br />
        return true;<br />
    if (fabs(tmp) &lt; EPS &amp;&amp; (dis(b, p[]) &lt; dis(c, p[])))<br />
        return true;<br />
    return false;<br />
}<br />
int graham_scan(TPoint hull[], int n) {<br />
    int top, i, k = ;<br />
    for (i = ; i &lt; n; ++i)<br />
        if ((p[k].y - p[i].y &gt; EPS)<br />
                || (fabs(p[i].y - p[k].y) &lt; EPS &amp;&amp; p[k].x - p[i].x &gt; EPS))<br />
            k = i;<br />
    swap(p[], p[k]);<br />
    sort(p + , p + n, graham_cmp);<br />
    hull[] = p[], hull[] = p[], hull[] = p[];<br />
    if (n &lt; )<br />
        return n;<br />
    else<br />
        top = ;<br />
    for (i = ; i &lt; n; ++i) {<br />
        while (top &gt;=  &amp;&amp; cross(hull[top - ], hull[top - ], p[i]) &lt; EPS)<br />
            --top;<br />
        hull[top++] = p[i];<br />
    }<br />
    return top;<br />
}<br />
bool bo[];<br />
int ans[];<br />
bool cmp(TPoint a,TPoint b)<br />
{<br />
    return a.x&lt;b.x-eps||(fabs(a.x-b.x)&lt;eps&amp;&amp;a.y&lt;b.y);<br />
}<br />
int main() {<br />
    int ri=,n;<br />
    while(scanf("%d",&amp;n)&amp;&amp;n)<br />
    {<br />
        int maxn=;<br />
        for(int i=;i&lt;n;++i)<br />
            ans[i]=;<br />
        for(int i=;i&lt;n;++i)<br />
        {<br />
            scanf("%lf%lf%d",&amp;s[i].x,&amp;s[i].y,&amp;s[i].v);<br />
            s[i].id=i;<br />
            maxn=std::max(maxn,s[i].v);<br />
        }<br />
        if(maxn==)<br />
        {<br />
            printf("Case #%d: ",++ri);<br />
            for(int i=;i&lt;n;++i)<br />
                printf("");<br />
            puts("");<br />
            continue;<br />
        }<br />
        int tail=;<br />
        for(int i=;i&lt;n;++i)<br />
        {<br />
            if(s[i].v==maxn&amp;&amp;maxn&gt;)<br />
            {<br />
                pp[tail]=s[i];<br />
                p[tail++]=s[i];<br />
            }<br />
        }<br />
        sort(p,p+tail,cmp);<br />
        int kk=;<br />
        for(int i=;i&lt;tail;++i)<br />
            if(i==tail-||fabs(p[i].x-p[i+].x)&gt;eps||fabs(p[i].y-p[i+].y)&gt;eps)<br />
                p[kk++]=p[i];<br />
        int h=graham_scan(hull,kk);<br />
        hull[h]=hull[];<br />
        for(int i=;i&lt;tail;++i)<br />
        {<br />
            int flag=;<br />
            for(int j=;j&lt;tail;++j)<br />
                if(i!=j&amp;&amp;fabs(pp[i].x-pp[j].x)&lt;eps&amp;&amp;fabs(pp[i].y-pp[j].y)&lt;eps)<br />
                {<br />
                    flag=;<br />
                    break;<br />
                }<br />
            if(flag)<br />
            {<br />
                ans[pp[i].id]=;<br />
                continue;<br />
            }<br />
            bool ok=false;<br />
            for(int j=;j&lt;h;++j)<br />
            {<br />
                if(fabs(cross(pp[i],hull[j],hull[j+]))&lt;eps)<br />
                    ok=true;<br />
            }<br />
            if(ok)<br />
                ans[pp[i].id]=;<br />
            else<br />
                ans[pp[i].id]=;<br />
        }<br />
        printf("Case #%d: ",++ri);<br />
        for(int i=;i&lt;n;++i)<br />
            printf("%d",ans[i]);<br />
        puts("");

    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1pk72q.html">poj3740</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jn4gw8.html">github初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1lre68.html">ThinkPHP&lowbar;基础（1）目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdr41j8.html">linux kernel&colon; possible SYN flooding on port 8080&period; Sending cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e770k9.html">NDK学习一&colon; 环境搭建Eclipse篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6pgz8.html">ovs-agent流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9617ln8.html">HDOJ 1856</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jy42l9.html">玩转HTML5移动页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6m4oq.html">ORACLE 优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdrlr48.html">HTML5之部分显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1pgx9.html">&lbrack;编码解码&rsqb; Base64 编码换行和&plus;号遍空格的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k56w29.html">ios 集合总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myedn8.html">spring框架-spring&period;xml配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgkewm8.html">迷宫问题-POJ 3984</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6zjj9.html">【Vue中的swiper轮播组件】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1k0l8.html">Python中模块之hashlib&amp;amp&semi;hmac的讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1zpkjq.html">Servlet&comma; Struts2和SpringMVC 并发访问线程安全问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd0n7z9.html">&lbrack;Swift&rsqb;LeetCode445&period; 两数相加 II &vert; Add Two Numbers II</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmv528.html">linux下php环境搭建&lpar;xampp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdn2kz9.html">Android 底部导航栏的xml</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/390e7onq.html">ubuntu 配置 jdk的一些常见问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql5mge8.html">由Excel表格导出Latex代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mpeno8.html">BZOJ 4517&colon; &lbrack;Sdoi2016&rsqb;排列计数</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv010j8.html">html&plus;js 的一些小问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql5jd68.html">Ubuntu中配置Thunderbird登录qq邮箱</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pxwjzq.html">我的Markdown笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdowoj8.html">android面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv027o8.html">jq 实现上下排序的一段代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdojoj8.html">arm-linux-androideabi-addr2line</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zjked9.html">Java多线程总结之线程安全队列Queue</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
